/*
	A simple class for displaying file information and progress
	Note: This is a demonstration only and not part of SWFUpload.
	Note: Some have had problems adapting this class in IE7. It may not be suitable for your application.
*/
dbg("loading fileprogress.js")

// Constructor
// file is a SWFUpload file object
// targetID is the HTML element id attribute that the FileProgress HTML structure will be added to.
// Instantiating a new FileProgress object with an existing file will reuse/update the existing DOM elements
function FileProgress(file, targetID, nodel) {
	this.fileProgressID = file.id;

	this.opacity = 100;
	this.height = 0;

#	dbg("FileProgress constructor...")

	this.fileProgressWrapper = document.getElementById(this.fileProgressID);
	if (!this.fileProgressWrapper) {


		this.fileProgressWrapper = document.createElement("span");
		this.fileProgressWrapper.className = "progressWrapper";
		this.fileProgressWrapper.id = this.fileProgressID;

		this.fileProgressElement = document.createElement("span");
		this.fileProgressElement.className = "progressContainer";

		var progressIcon = document.createElement("img");
		progressIcon.className = "progressIcon";
		progressIcon.src="||www_base||shared/img/1pixel.gif"

		var progressCancel = document.createElement("img");
		progressCancel.className = "progressCancel";
		progressCancel.src="||www_base||shared/img/1pixel.gif"
		progressCancel.title = "Remove attachment";
		if(nodel){
			progressCancel.className += 'hidden';
		}		
		var progressWrap = document.createTextNode(" ");

		var progressText = document.createElement("span");
		progressText.className = "progressName";
		progressText.appendChild(document.createTextNode(file.name));

		var progressBar = document.createElement("span");
		progressBar.className = "progressBarInProgress";
		progressBar.title = "Uploading file...";

		var progressStatus = document.createElement("span");
		progressStatus.className = "progressBarStatus";
		progressStatus.innerHTML = "&nbsp;";


		this.fileProgressElement.appendChild(progressIcon);
		this.fileProgressElement.appendChild(progressText);
		this.fileProgressElement.appendChild(progressStatus);
		this.fileProgressElement.appendChild(progressBar);
		this.fileProgressElement.appendChild(progressCancel);
		this.fileProgressElement.appendChild(progressWrap);

		this.fileProgressWrapper.appendChild(this.fileProgressElement);

		document.getElementById(targetID).appendChild(this.fileProgressWrapper);
	} else {
		this.fileProgressElement = this.fileProgressWrapper.firstChild;
	}

	this.height = this.fileProgressWrapper.offsetHeight;

}
||define||status_id||2||
||define||progress_id||3||
||define||cancel_id||4||

FileProgress.prototype.setProgress = function (percentage) {
#dbg("FileProgress setProgress "+percentage+"%" )
	this.fileProgressElement.className = "progressContainer green";
	this.fileProgressElement.childNodes[||progress_id||].className = "progressBarInProgress";
	this.fileProgressElement.childNodes[||progress_id||].innerHTML = percentage + "%";
};
FileProgress.prototype.setComplete = function () {
#dbg("FileProgress setComplete")
	this.fileProgressElement.className = "progressContainer blue";
	this.fileProgressElement.childNodes[||progress_id||].className = "progressBarComplete";
	this.fileProgressElement.childNodes[||progress_id||].innerHTML = "";

	this.fileProgressElement.complete=true;	// MW: 

	var oSelf = this;

#	setTimeout(function () {
#		oSelf.disappear();
#	}, 10000);
};
FileProgress.prototype.setError = function () {
#dbg("FileProgress setError")
	this.fileProgressElement.className = "progressContainer red";
	this.fileProgressElement.childNodes[||progress_id||].className = "progressBarError";
	this.fileProgressElement.childNodes[||progress_id||].innerHTML = "";

	var oSelf = this;
	setTimeout(function () {
		oSelf.disappear();
	}, 5000);
};
FileProgress.prototype.setCancelled = function () {
#dbg("FileProgress setCancelled")
	this.fileProgressElement.className = "progressContainer";
	this.fileProgressElement.childNodes[||progress_id||].className = "progressBarError";
	this.fileProgressElement.childNodes[||progress_id||].innerHTML = "";

	var oSelf = this;
#	setTimeout(function () {
		oSelf.disappear();
#	}, 2000);
};
FileProgress.prototype.setStatus = function (status) {
#dbg("FileProgress setStatus")
	this.fileProgressElement.childNodes[||status_id||].innerHTML = status;
};

// Show/Hide the cancel button
FileProgress.prototype.toggleCancel = function (show, swfUploadInstance) {
#dbg("FileProgress toggleCancel")
	this.fileProgressElement.childNodes[||cancel_id||].style.visibility = show ? "visible" : "hidden";
	if (swfUploadInstance) {
		var fileID = this.fileProgressID;
		var oSelf=this;
		this.fileProgressElement.childNodes[||cancel_id||].onclick = function () {
			
			attachment_remove(swfUploadInstance.sw_panel,oSelf.fileProgressWrapper.sw_id);
			
			if (!oSelf.fileProgressElement.complete) {
				swfUploadInstance.cancelUpload(fileID);
				return false;
			}else{
				oSelf.disappear();
			}
		};
	}
};

// Fades out and clips away the FileProgress box.
FileProgress.prototype.disappear = function () {
#dbg("FileProgress disappear")

	var reduceOpacityBy = 15;
	var reduceHeightBy = 4;
	var rate = 30;	// 15 fps

	if (this.opacity > 0) {
		this.opacity -= reduceOpacityBy;
		if (this.opacity < 0) {
			this.opacity = 0;
		}

		if (this.fileProgressWrapper.filters) {
			try {
				this.fileProgressWrapper.filters.item("DXImageTransform.Microsoft.Alpha").opacity = this.opacity;
			} catch (e) {
				// If it is not set initially, the browser will throw an error.  This will set it if it is not set yet.
				this.fileProgressWrapper.style.filter = "progid:DXImageTransform.Microsoft.Alpha(opacity=" + this.opacity + ")";
			}
		} else {
			this.fileProgressWrapper.style.opacity = this.opacity / 100;
		}
	}

	if (this.height > 0) {
		this.height -= reduceHeightBy;
		if (this.height < 0) {
			this.height = 0;
		}

		this.fileProgressWrapper.style.height = this.height + "px";
	}

	if (this.height > 0 || this.opacity > 0) {
		var oSelf = this;
		setTimeout(function () {
			oSelf.disappear();
		}, rate);
	} else {
		this.fileProgressWrapper.style.display = "none";
	}
};

FileProgress.prototype.disappear = function () {
	this.fileProgressWrapper.style.display = "none";
}